<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.scripts_ana.a_find_multiple_candidates.run_stats_all &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../../" id="documentation_options" src="../../../../../_static/documentation_options.js"></script>
        <script src="../../../../../_static/jquery.js"></script>
        <script src="../../../../../_static/underscore.js"></script>
        <script src="../../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../../_static/doctools.js"></script>
    <script src="../../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.scripts_ana.a_find_multiple_candidates.run_stats_all</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.scripts_ana.a_find_multiple_candidates.run_stats_all</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Compare the amount of multiple candidates in data and the</span>
<span class="sd">MC samples. This script produces a table that summarises the amount of</span>
<span class="sd">multiple candidates in every script, and plot them as well (as it</span>
<span class="sd">is easier to analyse plots than numbers in tables).</span>

<span class="sd">To run this script:</span>

<span class="sd">.. code-block::</span>

<span class="sd">    python ./c_compare_multiple_candidates/run.py (-o {outdir})</span>

<span class="sd">where the path to the OUTPUT directory can be specifed.</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>

<span class="kn">from</span> <span class="nn">uncertainties</span> <span class="kn">import</span> <span class="n">ufloat</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<span class="kn">import</span> <span class="nn">config</span>

<span class="kn">from</span> <span class="nn">lib.inout.serial</span> <span class="kn">import</span> <span class="n">load_json</span>
<span class="kn">from</span> <span class="nn">lib.handle.handle_str</span> <span class="kn">import</span> <span class="n">ufloat_into_latex</span>
<span class="kn">from</span> <span class="nn">lib.inout.table</span> <span class="kn">import</span> <span class="n">write_table</span>
<span class="kn">from</span> <span class="nn">lib.plot.params</span> <span class="kn">import</span> <span class="n">plot_params</span>
<span class="kn">from</span> <span class="nn">lib.plot</span> <span class="kn">import</span> <span class="n">tools</span>

<span class="kn">from</span> <span class="nn">multiple_candidates</span> <span class="kn">import</span> <span class="n">mulcan</span>
<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">paths</span><span class="p">,</span> <span class="n">labels</span><span class="p">,</span> <span class="n">colors</span><span class="p">,</span> <span class="n">columns</span>


<div class="viewcode-block" id="sum_dict_values"><a class="viewcode-back" href="../../../../../scripts.multiple_candidates.scripts_ana.a_find_multiple_candidates.html#scripts.multiple_candidates.scripts_ana.a_find_multiple_candidates.run_stats_all.sum_dict_values">[docs]</a><span class="k">def</span> <span class="nf">sum_dict_values</span><span class="p">(</span><span class="n">dic</span><span class="p">:</span> <span class="nb">dict</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Get the sum of the values of a dictionnary.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="nb">sum</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">dic</span><span class="o">.</span><span class="n">values</span><span class="p">()))</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>

    <span class="c1"># PRELIMINARY =========================================================</span>
    <span class="c1"># Parser</span>
    <span class="n">outdir</span> <span class="o">=</span> <span class="n">mulcan</span><span class="o">.</span><span class="n">get_result_gen_parser</span><span class="p">(</span>
        <span class="n">description</span><span class="o">=</span><span class="p">(</span>
            <span class="s2">&quot;Compare the amount of multiple candidates in all the samples&quot;</span><span class="p">),</span>
        <span class="n">list_arguments</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;outdir&quot;</span><span class="p">]</span>
    <span class="p">)</span>
    <span class="n">format_values</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="n">outdir</span><span class="o">=</span><span class="n">outdir</span><span class="p">,</span> <span class="n">sample_type</span><span class="o">=</span><span class="s2">&quot;all&quot;</span><span class="p">)</span>
    <span class="n">image_dir</span> <span class="o">=</span> <span class="n">config</span><span class="o">.</span><span class="n">image_dir_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
        <span class="o">**</span><span class="n">format_values</span>
    <span class="p">)</span>

    <span class="c1"># TABLE ===============================================================</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;PRODUCE TABLE&quot;</span><span class="p">)</span>

    <span class="n">dict_fracs_flavours_row_types</span> <span class="o">=</span> <span class="p">{</span>
        <span class="n">row_type</span><span class="p">:</span> <span class="p">{</span>
            <span class="n">flavour</span><span class="p">:</span> <span class="p">{}</span> <span class="k">for</span> <span class="n">flavour</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_FLAVOURS</span>
        <span class="p">}</span>
        <span class="k">for</span> <span class="n">row_type</span> <span class="ow">in</span> <span class="n">columns</span><span class="o">.</span><span class="n">LIST_ROW_TYPES</span><span class="p">}</span>

    <span class="k">for</span> <span class="n">flavour</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_FLAVOURS</span><span class="p">:</span>
        <span class="n">table</span> <span class="o">=</span> <span class="p">[</span>
            <span class="p">[</span>
                <span class="s2">&quot;Sample&quot;</span><span class="p">,</span>
                <span class="s2">&quot;# multiple candidates&quot;</span><span class="p">,</span> <span class="s2">&quot;# candidates&quot;</span><span class="p">,</span>
                <span class="s2">&quot;Ratio of multiple candidates&quot;</span><span class="p">,</span>
                <span class="s2">&quot;# multiple events&quot;</span><span class="p">,</span> <span class="s2">&quot;# events&quot;</span><span class="p">,</span> <span class="s2">&quot;Ratio of multiple events&quot;</span>
            <span class="p">]</span>
        <span class="p">]</span>

        <span class="k">for</span> <span class="n">sample_type</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_SAMPLE_TYPES</span><span class="p">:</span>
            <span class="n">dict_mulcan</span> <span class="o">=</span> <span class="n">load_json</span><span class="p">(</span>
                <span class="n">path</span><span class="o">=</span><span class="n">config</span><span class="o">.</span><span class="n">json_path_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                    <span class="n">flavour</span><span class="o">=</span><span class="n">flavour</span><span class="p">,</span>
                    <span class="n">sample_type</span><span class="o">=</span><span class="n">sample_type</span><span class="p">,</span>
                    <span class="n">outdir</span><span class="o">=</span><span class="n">outdir</span>
                <span class="p">)</span>
            <span class="p">)</span>
            <span class="n">line</span> <span class="o">=</span> <span class="p">[</span><span class="n">labels</span><span class="o">.</span><span class="n">DICT_SAMPLE_TYPE_LABELS</span><span class="p">[</span><span class="n">sample_type</span><span class="p">]]</span>

            <span class="k">for</span> <span class="n">row_type</span> <span class="ow">in</span> <span class="n">columns</span><span class="o">.</span><span class="n">LIST_ROW_TYPES</span><span class="p">:</span>
                <span class="n">line</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
                    <span class="n">sum_dict_values</span><span class="p">(</span><span class="n">dict_mulcan</span><span class="p">[</span><span class="sa">f</span><span class="s2">&quot;nb_multiple_</span><span class="si">{row_type}</span><span class="s2">&quot;</span><span class="p">]))</span>
                <span class="n">line</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
                    <span class="n">sum_dict_values</span><span class="p">(</span><span class="n">dict_mulcan</span><span class="p">[</span><span class="sa">f</span><span class="s2">&quot;nb_</span><span class="si">{row_type}</span><span class="s2">&quot;</span><span class="p">]))</span>

                <span class="n">nb_multiple</span> <span class="o">=</span> <span class="n">ufloat</span><span class="p">(</span><span class="n">line</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">],</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">line</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">]))</span>
                <span class="n">nb_total</span> <span class="o">=</span> <span class="n">ufloat</span><span class="p">(</span><span class="n">line</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">line</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]))</span>
                <span class="n">ratio</span> <span class="o">=</span> <span class="n">nb_multiple</span> <span class="o">/</span> <span class="n">nb_total</span> <span class="o">*</span> <span class="mi">100</span>

                <span class="k">if</span> <span class="n">ratio</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="n">ratio_str</span> <span class="o">=</span> <span class="s1">&#39;0&#39;</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">ratio_str</span> <span class="o">=</span> <span class="n">ufloat_into_latex</span><span class="p">(</span><span class="n">ratio</span><span class="p">,</span> <span class="n">with_dollar</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
                <span class="n">line</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{ratio_str}</span><span class="s2"> %&quot;</span><span class="p">)</span>
                <span class="n">dict_fracs_flavours_row_types</span><span class="p">[</span><span class="n">row_type</span><span class="p">][</span><span class="n">flavour</span><span class="p">][</span><span class="n">sample_type</span><span class="p">]</span> \
                    <span class="o">=</span> <span class="n">ratio</span>

            <span class="n">table</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">line</span><span class="p">)</span>

            <span class="n">write_table</span><span class="p">(</span>
                <span class="n">table</span><span class="p">,</span>
                <span class="n">path</span><span class="o">=</span><span class="n">config</span><span class="o">.</span><span class="n">table_path_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                    <span class="n">row_type</span><span class="o">=</span><span class="n">row_type</span><span class="p">,</span> <span class="n">flavour</span><span class="o">=</span><span class="n">flavour</span><span class="p">,</span>
                    <span class="o">**</span><span class="n">format_values</span>
                <span class="p">)</span>
            <span class="p">)</span>

    <span class="c1"># PLOT =================================================================</span>
    <span class="n">dict_cat_kwargs</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">flavour</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_FLAVOURS</span><span class="p">:</span>
        <span class="n">dict_cat_kwargs</span><span class="p">[</span><span class="n">flavour</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span>
            <span class="s2">&quot;label&quot;</span><span class="p">:</span> <span class="sa">f</span><span class="s2">&quot;$</span><span class="se">\\</span><span class="s2">ell = </span><span class="si">{labels.DICT_FLAVOUR_LABELS[flavour]}</span><span class="s2">$&quot;</span><span class="p">,</span>
            <span class="s2">&quot;color&quot;</span><span class="p">:</span> <span class="n">colors</span><span class="o">.</span><span class="n">DICT_FLAVOUR_COLORS</span><span class="p">[</span><span class="n">flavour</span><span class="p">]</span>
        <span class="p">}</span>

    <span class="k">for</span> <span class="n">type_row</span> <span class="ow">in</span> <span class="n">columns</span><span class="o">.</span><span class="n">LIST_ROW_TYPES</span><span class="p">:</span>
        <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plot_params</span><span class="p">(</span>
            <span class="n">dict_fracs_flavours_row_types</span><span class="p">[</span><span class="n">type_row</span><span class="p">],</span>
            <span class="n">labels</span><span class="o">.</span><span class="n">DICT_SAMPLE_TYPE_LABELS</span><span class="p">,</span>
            <span class="n">dict_cat_kwargs</span><span class="o">=</span><span class="n">dict_cat_kwargs</span><span class="p">,</span>
            <span class="n">xlabel</span><span class="o">=</span><span class="s2">&quot;Value in %&quot;</span><span class="p">,</span>
            <span class="n">max_offset</span><span class="o">=</span><span class="mf">0.1</span>
        <span class="p">)</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Fraction of multiple </span><span class="si">{type_row}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="n">tools</span><span class="o">.</span><span class="n">save_fig</span><span class="p">(</span>
            <span class="n">fig</span><span class="p">,</span>
            <span class="n">path</span><span class="o">=</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">image_dir</span><span class="p">,</span> <span class="sa">f</span><span class="s2">&quot;ratio_multiple_</span><span class="si">{type_row}</span><span class="s2">&quot;</span><span class="p">),</span>
            <span class="n">tight_layout</span><span class="o">=</span><span class="kc">False</span>
        <span class="p">)</span>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>